From cc50605b73b822bc9d47799122473d2d58e61b9d Mon Sep 17 00:00:00 2001
From: Christina Fu <cfu@redhat.com>
Date: Mon, 15 May 2017 18:15:36 -0700
Subject: [PATCH] Bug 1447080 - CC: CMC: allow enrollment key signed
 (self-signed) CMC with identity proof This patch implements the self-signed
 CMC requests, where the request is signed by the public key of the underlying
 request (PKCS#10 or CRMF). The scenario for when this method is used is when
 there was no existing signing cert for the user has been issued before, and
 once it is issued, it can be used to sign subsequent cert requests by the
 same user. The new enrollment profile introduced is :
 caFullCMCSelfSignedCert.cfg The new option introduced to both CRMFPopClient
 and PKCS10Client is "-y" which will add the required SubjectKeyIdentifier to
 the underlying request. When a CMC request is self-signed, no auditSubjectID
 is available until Identification Proof (v2) is verified, however, the cert
 subject DN is recorded in log as soon as it was available for additional
 information.

---
 base/ca/shared/conf/CS.cfg                         |   8 +-
 .../shared/profiles/ca/caFullCMCSelfSignedCert.cfg |  85 ++++
 base/ca/shared/webapps/ca/WEB-INF/web.xml          |  28 ++
 .../certsrv/authentication/IAuthManager.java       |   1 +
 .../certsrv/authentication/IAuthSubsystem.java     |   5 +
 .../com/netscape/certsrv/logging/AuditEvent.java   |  16 +-
 .../src/com/netscape/cmstools/CMCRequest.java      | 166 ++++++-
 .../src/com/netscape/cmstools/CRMFPopClient.java   |  32 ++
 .../src/com/netscape/cmstools/PKCS10Client.java    |  87 ++--
 .../cms/authentication/CMCUserSignedAuth.java      | 543 +++++++++++++--------
 .../netscape/cms/profile/common/EnrollProfile.java | 163 ++++++-
 .../netscape/cms/profile/def/CAEnrollDefault.java  |  37 +-
 .../def/SubjectKeyIdentifierExtDefault.java        |  21 +-
 .../netscape/cms/profile/input/EnrollInput.java    |   8 +-
 .../cms/servlet/processors/CRMFProcessor.java      |  18 +-
 .../servlet/profile/ProfileSubmitCMCServlet.java   |  49 +-
 base/server/cmsbundle/src/LogMessages.properties   |  32 +-
 .../com/netscape/cmscore/security/KeyCertUtil.java |  12 +-
 .../com/netscape/cmsutil/crypto/CryptoUtil.java    | 181 ++++++-
 base/util/src/netscape/security/pkcs/PKCS10.java   |  31 +-
 .../netscape/security/pkcs/PKCS10Attributes.java   |   2 +
 21 files changed, 1145 insertions(+), 380 deletions(-)
 create mode 100644 base/ca/shared/profiles/ca/caFullCMCSelfSignedCert.cfg

diff --git a/base/ca/shared/profiles/ca/caFullCMCSelfSignedCert.cfg b/base/ca/shared/profiles/ca/caFullCMCSelfSignedCert.cfg
new file mode 100644
index 0000000..db3fbd6
--- /dev/null
+++ b/base/ca/shared/profiles/ca/caFullCMCSelfSignedCert.cfg
@@ -0,0 +1,85 @@
+desc=This certificate profile is for enrolling user certificates by using the self-signed CMC certificate request
+enable=true
+enableBy=admin
+name=Self-Signed CMC User Certificate Enrollment
+visible=false
+auth.instance_id=CMCUserSignedAuth
+input.list=i1,i2
+input.i1.class_id=cmcCertReqInputImpl
+input.i2.class_id=submitterInfoInputImpl
+output.list=o1
+output.o1.class_id=certOutputImpl
+policyset.list=cmcUserCertSet
+policyset.cmcUserCertSet.list=1,2,3,4,5,6,7,8
+policyset.cmcUserCertSet.1.constraint.class_id=subjectNameConstraintImpl
+policyset.cmcUserCertSet.1.constraint.name=Subject Name Constraint
+policyset.cmcUserCertSet.1.constraint.params.accept=true
+policyset.cmcUserCertSet.1.constraint.params.pattern=.*
+policyset.cmcUserCertSet.1.default.class_id=userSubjectNameDefaultImpl
+policyset.cmcUserCertSet.1.default.name=Subject Name Default
+policyset.cmcUserCertSet.1.default.params.name=
+policyset.cmcUserCertSet.2.constraint.class_id=validityConstraintImpl
+policyset.cmcUserCertSet.2.constraint.name=Validity Constraint
+policyset.cmcUserCertSet.2.constraint.params.notAfterCheck=false
+policyset.cmcUserCertSet.2.constraint.params.notBeforeCheck=false
+policyset.cmcUserCertSet.2.constraint.params.range=365
+policyset.cmcUserCertSet.2.default.class_id=validityDefaultImpl
+policyset.cmcUserCertSet.2.default.name=Validity Default
+policyset.cmcUserCertSet.2.default.params.range=180
+policyset.cmcUserCertSet.2.default.params.startTime=0
+policyset.cmcUserCertSet.3.constraint.class_id=keyConstraintImpl
+policyset.cmcUserCertSet.3.constraint.name=Key Constraint
+policyset.cmcUserCertSet.3.constraint.params.keyParameters=1024,2048,3072,4096,nistp256,nistp521
+policyset.cmcUserCertSet.3.constraint.params.keyType=-
+policyset.cmcUserCertSet.3.default.class_id=userKeyDefaultImpl
+policyset.cmcUserCertSet.3.default.name=Key Default
+policyset.cmcUserCertSet.4.constraint.class_id=noConstraintImpl
+policyset.cmcUserCertSet.4.constraint.name=No Constraint
+policyset.cmcUserCertSet.4.default.class_id=authorityKeyIdentifierExtDefaultImpl
+policyset.cmcUserCertSet.4.default.name=Authority Key Identifier Default
+policyset.cmcUserCertSet.5.constraint.class_id=noConstraintImpl
+policyset.cmcUserCertSet.5.constraint.name=No Constraint
+policyset.cmcUserCertSet.5.default.class_id=authInfoAccessExtDefaultImpl
+policyset.cmcUserCertSet.5.default.name=AIA Extension Default
+policyset.cmcUserCertSet.5.default.params.authInfoAccessADEnable_0=true
+policyset.cmcUserCertSet.5.default.params.authInfoAccessADLocationType_0=URIName
+policyset.cmcUserCertSet.5.default.params.authInfoAccessADLocation_0=
+policyset.cmcUserCertSet.5.default.params.authInfoAccessADMethod_0=1.3.6.1.5.5.7.48.1
+policyset.cmcUserCertSet.5.default.params.authInfoAccessCritical=false
+policyset.cmcUserCertSet.5.default.params.authInfoAccessNumADs=1
+policyset.cmcUserCertSet.6.constraint.class_id=keyUsageExtConstraintImpl
+policyset.cmcUserCertSet.6.constraint.name=Key Usage Extension Constraint
+policyset.cmcUserCertSet.6.constraint.params.keyUsageCritical=true
+policyset.cmcUserCertSet.6.constraint.params.keyUsageCrlSign=false
+policyset.cmcUserCertSet.6.constraint.params.keyUsageDataEncipherment=false
+policyset.cmcUserCertSet.6.constraint.params.keyUsageDecipherOnly=false
+policyset.cmcUserCertSet.6.constraint.params.keyUsageDigitalSignature=true
+policyset.cmcUserCertSet.6.constraint.params.keyUsageEncipherOnly=false
+policyset.cmcUserCertSet.6.constraint.params.keyUsageKeyAgreement=false
+policyset.cmcUserCertSet.6.constraint.params.keyUsageKeyCertSign=false
+policyset.cmcUserCertSet.6.constraint.params.keyUsageKeyEncipherment=true
+policyset.cmcUserCertSet.6.constraint.params.keyUsageNonRepudiation=true
+policyset.cmcUserCertSet.6.default.class_id=keyUsageExtDefaultImpl
+policyset.cmcUserCertSet.6.default.name=Key Usage Default
+policyset.cmcUserCertSet.6.default.params.keyUsageCritical=true
+policyset.cmcUserCertSet.6.default.params.keyUsageCrlSign=false
+policyset.cmcUserCertSet.6.default.params.keyUsageDataEncipherment=false
+policyset.cmcUserCertSet.6.default.params.keyUsageDecipherOnly=false
+policyset.cmcUserCertSet.6.default.params.keyUsageDigitalSignature=true
+policyset.cmcUserCertSet.6.default.params.keyUsageEncipherOnly=false
+policyset.cmcUserCertSet.6.default.params.keyUsageKeyAgreement=false
+policyset.cmcUserCertSet.6.default.params.keyUsageKeyCertSign=false
+policyset.cmcUserCertSet.6.default.params.keyUsageKeyEncipherment=true
+policyset.cmcUserCertSet.6.default.params.keyUsageNonRepudiation=true
+policyset.cmcUserCertSet.7.constraint.class_id=noConstraintImpl
+policyset.cmcUserCertSet.7.constraint.name=No Constraint
+policyset.cmcUserCertSet.7.default.class_id=extendedKeyUsageExtDefaultImpl
+policyset.cmcUserCertSet.7.default.name=Extended Key Usage Extension Default
+policyset.cmcUserCertSet.7.default.params.exKeyUsageCritical=false
+policyset.cmcUserCertSet.7.default.params.exKeyUsageOIDs=1.3.6.1.5.5.7.3.2,1.3.6.1.5.5.7.3.4
+policyset.cmcUserCertSet.8.constraint.class_id=signingAlgConstraintImpl
+policyset.cmcUserCertSet.8.constraint.name=No Constraint
+policyset.cmcUserCertSet.8.constraint.params.signingAlgsAllowed=SHA1withRSA,SHA256withRSA,SHA512withRSA,MD5withRSA,MD2withRSA,SHA1withDSA,SHA1withEC,SHA256withEC,SHA384withRSA,SHA384withEC,SHA512withEC
+policyset.cmcUserCertSet.8.default.class_id=signingAlgDefaultImpl
+policyset.cmcUserCertSet.8.default.name=Signing Alg
+policyset.cmcUserCertSet.8.default.params.signingAlg=-
diff --git a/base/common/src/com/netscape/certsrv/authentication/IAuthManager.java b/base/common/src/com/netscape/certsrv/authentication/IAuthManager.java
index 21639e2..7d30d2e 100644
--- a/base/common/src/com/netscape/certsrv/authentication/IAuthManager.java
+++ b/base/common/src/com/netscape/certsrv/authentication/IAuthManager.java
@@ -33,6 +33,7 @@ public interface IAuthManager {
 
     /* standard credential for CMC request signing cert */
     public static final String CRED_CMC_SIGNING_CERT = "cmcSigningCert";
+    public static final String CRED_CMC_SELF_SIGNED = "cmcSelfSigned";
 
     /**
      * Standard credential for client cert's serial number from revocation.
diff --git a/base/common/src/com/netscape/certsrv/authentication/IAuthSubsystem.java b/base/common/src/com/netscape/certsrv/authentication/IAuthSubsystem.java
index e1ccc2d..9089527 100644
--- a/base/common/src/com/netscape/certsrv/authentication/IAuthSubsystem.java
+++ b/base/common/src/com/netscape/certsrv/authentication/IAuthSubsystem.java
@@ -119,6 +119,11 @@ public interface IAuthSubsystem extends ISubsystem {
     public static final String CMCAUTH_AUTHMGR_ID = "CMCAuth";
 
     /**
+     * Constant for CMC user-signed authentication manager ID.
+     */
+    public static final String CMC_USER_SIGNED_AUTH_AUTHMGR_ID = "CMCUserSignedAuth";
+
+    /**
      * Authenticate the given credentials using the given manager name.
      *
      * @param authCred The authentication credentials
diff --git a/base/common/src/com/netscape/certsrv/logging/AuditEvent.java b/base/common/src/com/netscape/certsrv/logging/AuditEvent.java
index 7a4aa9b..9d202df 100644
--- a/base/common/src/com/netscape/certsrv/logging/AuditEvent.java
+++ b/base/common/src/com/netscape/certsrv/logging/AuditEvent.java
@@ -126,8 +126,14 @@ public class AuditEvent implements IBundleLogEvent {
             "LOGGING_SIGNED_AUDIT_AUTH_SUCCESS_3";
     public final static String CERT_PROFILE_APPROVAL =
             "LOGGING_SIGNED_AUDIT_CERT_PROFILE_APPROVAL_4";
-    public final static String PROOF_OF_POSSESSION =
-            "LOGGING_SIGNED_AUDIT_PROOF_OF_POSSESSION_2";
+    public final static String PROOF_OF_POSSESSION_SUCCESS =
+            "LOGGING_SIGNED_AUDIT_PROOF_OF_POSSESSION_SUCCESS_2";
+    public final static String PROOF_OF_POSSESSION_FAILURE =
+            "LOGGING_SIGNED_AUDIT_PROOF_OF_POSSESSION_FAILURE_3";
+    public final static String CMC_PROOF_OF_IDENTIFICATION_SUCCESS =
+            "LOGGING_SIGNED_AUDIT_CMC_PROOF_OF_IDENTIFICATION_SUCCESS_2";
+    public final static String CMC_PROOF_OF_IDENTIFICATION_FAILURE =
+            "LOGGING_SIGNED_AUDIT_CMC_PROOF_OF_IDENTIFICATION_FAILURE_3";
 
     public final static String CRL_RETRIEVAL =
             "LOGGING_SIGNED_AUDIT_CRL_RETRIEVAL_3";
@@ -145,8 +151,10 @@ public class AuditEvent implements IBundleLogEvent {
             "LOGGING_SIGNED_AUDIT_OCSP_REMOVE_CA_REQUEST_PROCESSED_FAILURE_3";
     public final static String CMC_SIGNED_REQUEST_SIG_VERIFY =
             "LOGGING_SIGNED_AUDIT_CMC_SIGNED_REQUEST_SIG_VERIFY_5";
-    public final static String CMC_USER_SIGNED_REQUEST_SIG_VERIFY =
-            "LOGGING_SIGNED_AUDIT_CMC_USER_SIGNED_REQUEST_SIG_VERIFY_5";
+    public final static String CMC_USER_SIGNED_REQUEST_SIG_VERIFY_SUCCESS =
+            "LOGGING_SIGNED_AUDIT_CMC_USER_SIGNED_REQUEST_SIG_VERIFY_SUCCESS_5";
+    public final static String CMC_USER_SIGNED_REQUEST_SIG_VERIFY_FAILURE =
+            "LOGGING_SIGNED_AUDIT_CMC_USER_SIGNED_REQUEST_SIG_VERIFY_FAILURE_6";
 
     public final static String COMPUTE_RANDOM_DATA_REQUEST =
             "LOGGING_SIGNED_AUDIT_COMPUTE_RANDOM_DATA_REQUEST_2";
diff --git a/base/java-tools/src/com/netscape/cmstools/CMCRequest.java b/base/java-tools/src/com/netscape/cmstools/CMCRequest.java
index ac523ad..6e27cb1 100644
--- a/base/java-tools/src/com/netscape/cmstools/CMCRequest.java
+++ b/base/java-tools/src/com/netscape/cmstools/CMCRequest.java
@@ -103,6 +103,9 @@ import com.netscape.cmsutil.util.HMACDigest;
 import com.netscape.cmsutil.util.Utils;
 
 import netscape.security.pkcs.PKCS10;
+import netscape.security.x509.KeyIdentifier;
+import netscape.security.x509.PKIXExtensions;
+import netscape.security.x509.SubjectKeyIdentifierExtension;
 import netscape.security.x509.X500Name;
 import netscape.security.x509.X509CertImpl;
 
@@ -121,6 +124,7 @@ public class CMCRequest {
     public static final int ARGC = 1;
     public static final String HEADER = "-----BEGIN";
     public static final String TRAILER = "-----END";
+    public static SubjectKeyIdentifierExtension skiExtn = null;
 
     void cleanArgs(String[] s) {
 
@@ -193,7 +197,7 @@ public class CMCRequest {
     }
 
     /**
-     * signData signs the request PKIData
+     * signData signs the request PKIData using existing cert
      *
      * @param signerCert the certificate of the authorized signer of the CMC revocation request.
      * @param nickname the nickname of the certificate inside the token.
@@ -212,6 +216,15 @@ public class CMCRequest {
         SignedData req = null;
         System.out.println(method + "begins: ");
 
+        if (signerCert == null ||
+                tokenName == null ||
+                nickname == null ||
+                manager == null ||
+                pkidata == null) {
+            System.out.println(method + "method parameters cannot be null");
+            System.exit(1);
+        }
+
         try {
             java.security.PrivateKey privKey = null;
             SignerIdentifier si = null;
@@ -232,7 +245,72 @@ public class CMCRequest {
             privKey = getPrivateKey(tokenName, nickname);
             if (privKey != null)
                 System.out.println(method + " got signer privKey");
+            else {
+                System.out.println(method + " signer privKey not foudn on token");
+                System.exit(1);
+            }
+
+            org.mozilla.jss.crypto.X509Certificate[] certChain = manager.buildCertificateChain(signerCert);
+            req = createSignedData(privKey, si, certChain, pkidata);
+
+            System.out.println(method + "signed request generated.");
+        } catch (Exception e) {
+            e.printStackTrace();
+            System.exit(1);
+        }
+
+        return req;
+    }
+
+    /*
+     * signData self-signs the PKIData using the private key that matches
+     * the public key in the request
+     */
+    static SignedData signData(
+            java.security.PrivateKey privKey,
+            PKIData pkidata) {
+        String method = "signData for selfSign: ";
+        System.out.println(method + "begins: ");
+        SignedData req = null;
+
+        if (privKey == null ||
+                pkidata == null) {
+            System.out.println(method + "method parameters cannot be null");
+            System.exit(1);
+        }
+
+        KeyIdentifier keyIdObj = null;
+        try {
+            keyIdObj = (KeyIdentifier) skiExtn.get(SubjectKeyIdentifierExtension.KEY_ID);
+            SignerIdentifier si = new SignerIdentifier(
+                    SignerIdentifier.SUBJECT_KEY_IDENTIFIER,
+                    null, new OCTET_STRING(keyIdObj.getIdentifier()));
+            req = createSignedData(privKey, si, null /*certChain*/, pkidata);
+        } catch (Exception e) {
+            e.printStackTrace();
+            System.exit(1);
+        }
+        return req;
+    }
 
+    static SignedData createSignedData(
+            java.security.PrivateKey privKey,
+            SignerIdentifier signerId,
+            org.mozilla.jss.crypto.X509Certificate[] certChain,
+            PKIData pkidata) {
+
+        String method = "createSignedData: ";
+        System.out.println(method + "begins");
+        if (privKey == null ||
+                signerId == null ||
+                pkidata == null) {
+            // certChain could be null
+            System.out.println(method + "method parameters cannot be null");
+            System.exit(1);
+        }
+
+        SignedData req = null;
+        try {
             EncapsulatedContentInfo ci = new EncapsulatedContentInfo(OBJECT_IDENTIFIER.id_cct_PKIData, pkidata);
             DigestAlgorithm digestAlg = null;
             SignatureAlgorithm signAlg = getSigningAlgFromPrivate(privKey);
@@ -251,11 +329,18 @@ public class CMCRequest {
                 pkidata.encode(ostream);
                 digest = SHADigest.digest(ostream.toByteArray());
             } catch (NoSuchAlgorithmException e) {
-                System.out.println(e); System.exit(1);}
+                System.out.println(e);
+                System.exit(1);
+            }
             System.out.println(method + "digest created for pkidata");
 
-            SignerInfo signInfo = new SignerInfo(si, null, null, OBJECT_IDENTIFIER.id_cct_PKIData, digest, signAlg,
+            SignerInfo signInfo = new SignerInfo(signerId, null, null,
+                    OBJECT_IDENTIFIER.id_cct_PKIData, digest, signAlg,
                     (org.mozilla.jss.crypto.PrivateKey) privKey);
+
+            String digestAlgName = signInfo.getDigestEncryptionAlgorithm().toString();
+            System.out.println(method + "digest algorithm =" + digestAlgName);
+
             SET signInfos = new SET();
             signInfos.addElement(signInfo);
 
@@ -266,21 +351,20 @@ public class CMCRequest {
                 digestAlgs.addElement(ai);
             }
 
-            org.mozilla.jss.crypto.X509Certificate[] agentChain = manager.buildCertificateChain(signerCert);
             SET certs = new SET();
-
-            for (int i = 0; i < agentChain.length; i++) {
-                ANY cert = new ANY(agentChain[i].getEncoded());
-                certs.addElement(cert);
+            if (certChain != null) {
+                System.out.println(method + "building cert chain");
+                for (int i = 0; i < certChain.length; i++) {
+                    ANY cert = new ANY(certChain[i].getEncoded());
+                    certs.addElement(cert);
+                }
             }
 
             req = new SignedData(digestAlgs, ci, certs, null, signInfos);
-            System.out.println(method + "signed request generated.");
         } catch (Exception e) {
             e.printStackTrace();
             System.exit(1);
         }
-
         return req;
     }
 
@@ -325,6 +409,7 @@ public class CMCRequest {
      * @return request in PKIData
      */
     static PKIData createPKIData(
+            String selfSign,
             String[] rValue, String format, String transactionMgtEnable,
             String transactionMgtId,
             String identificationEnable, String identification,
@@ -387,13 +472,26 @@ public class CMCRequest {
                         }
                         certReqMsg = (CertReqMsg) crmfMsgs.elementAt(0);
 
+                        CertRequest certReq = certReqMsg.getCertReq();
+                        CertTemplate certTemplate = certReq.getCertTemplate();
+                        if (selfSign.equals("true")) {
+                            skiExtn = (SubjectKeyIdentifierExtension) CryptoUtil.getExtensionFromCertTemplate(
+                                    certTemplate,
+                                    PKIXExtensions.SubjectKey_Id);
+                            if (skiExtn != null) {
+                                System.out.println(method +
+                                        " SubjectKeyIdentifier extension found in self-signed request");
+                            } else {
+                                System.out.println(method +
+                                        " SubjectKeyIdentifier extension missing in self-signed request");
+                                System.exit(1);
+                            }
+                        }
                         if (popLinkWitnessV2Enable.equals("true")) {
                             System.out.println(method +
                                     "popLinkWitnessV2 enabled. reconstructing crmf");
                             //crmf reconstruction to include PopLinkWitnessV2 control
-                            CertRequest certReq = certReqMsg.getCertReq();
                             INTEGER certReqId = certReq.getCertReqId();
-                            CertTemplate certTemplate = certReq.getCertTemplate();
                             SEQUENCE controls = certReq.getControls();
                             controls.addElement(new AVA(OBJECT_IDENTIFIER.id_cmc_popLinkWitnessV2,
                                     popLinkWitnessV2Control));
@@ -449,6 +547,22 @@ public class CMCRequest {
                             System.out.println(method + " Excception:" + e2.toString());
                             System.exit(1);
                         }
+
+                        if (selfSign.equals("true")) {
+                            try {
+                                skiExtn = (SubjectKeyIdentifierExtension) CryptoUtil.getExtensionFromPKCS10(
+                                        pkcs, "SubjectKeyIdentifier");
+                            } catch (IOException e) {
+                                System.out.println(method + "getting SubjectKeyIdentifiere..." + e);
+                            }
+
+                            if (skiExtn != null) {
+                                System.out.println(method + " SubjectKeyIdentifier extension found");
+                            } else {
+                                System.out.println(method + " SubjectKeyIdentifier extension missing");
+                                System.exit(1);
+                            }
+                        }
                         ByteArrayInputStream crInputStream = new ByteArrayInputStream(
                                 pkcs.toByteArray());
                         CertificationRequest cr = (CertificationRequest) CertificationRequest.getTemplate()
@@ -661,8 +775,13 @@ public class CMCRequest {
         System.out.println("");
         System.out.println("#nickname: nickname for agent certificate which will be used");
         System.out.println("#to sign the CMC full request.");
+        System.out.println("#selfSign: if selfSign is true, the CMC request will be");
+        System.out.println("#signed with the pairing private key of the request;");
+        System.out.println("#and in which case the nickname will be ignored");
         System.out.println("nickname=CMS Agent Certificate");
         System.out.println("");
+        System.out.println("selfSign=false");
+        System.out.println("");
         System.out.println("#dbdir: directory for cert8.db, key3.db and secmod.db");
         System.out.println("dbdir=./");
         System.out.println("");
@@ -1700,6 +1819,7 @@ public class CMCRequest {
         String popLinkWitnessV2Enable = "false", popLinkWitnessV2keyGenAlg = "SHA256", popLinkWitnessV2macAlg = "SHA256";
         String popLinkWitnessEnable = "false";
         String bodyPartIDs = null, lraPopWitnessEnable = "false";
+        String selfSign = "false";
 
         System.out.println("");
 
@@ -1760,6 +1880,8 @@ public class CMCRequest {
                         decryptedPopEnable = val;
                     } else if (name.equals("encryptedPopResponseFile")) {
                         encryptedPopResponseFile = val;
+                    } else if (name.equals("request.selfSign")) {
+                        selfSign = val;
                     } else if (name.equals("request.privKeyId")) {
                         privKeyId = val;
                     } else if (name.equals("decryptedPopRequestFile")) {
@@ -1846,7 +1968,7 @@ public class CMCRequest {
             printUsage();
         }
 
-        if (nickname == null) {
+        if (!selfSign.equals("true") && nickname == null) {
             System.out.println("Missing nickname.");
             printUsage();
         }
@@ -1898,14 +2020,14 @@ public class CMCRequest {
                 System.out.println("got signerCert: "+ certname.toString());
             }
 
-            //cfu
             ContentInfo cmcblob = null;
             PKIData pkidata = null;
             PrivateKey privk = null;
-            if (decryptedPopEnable.equalsIgnoreCase("true") ||
+            if (selfSign.equalsIgnoreCase("true") ||
+                    decryptedPopEnable.equalsIgnoreCase("true") ||
                     popLinkWitnessV2Enable.equalsIgnoreCase("true")) {
                 if (privKeyId == null) {
-                    System.out.println("ecryptedPop.enable or popLinkWitnessV2 true, but privKeyId not specified.");
+                    System.out.println("selfSign or ecryptedPop.enable or popLinkWitnessV2 true, but privKeyId not specified.");
                     printUsage();
                 } else {
                     System.out.println("got request privKeyId: " + privKeyId);
@@ -2095,6 +2217,7 @@ public class CMCRequest {
 
                 // create the request PKIData
                 pkidata = createPKIData(
+                        selfSign,
                         requests,
                         format, transactionMgtEnable, transactionMgtId,
                         identificationEnable, identification,
@@ -2114,7 +2237,16 @@ public class CMCRequest {
             }
 
             // sign the request
-            SignedData signedData = signData(signerCert, tokenName, nickname, cm, pkidata);
+            SignedData signedData = null;
+            if (selfSign.equalsIgnoreCase("true")) {
+                // selfSign signes with private key
+                System.out.println("selfSign is true...");
+                signedData = signData(privk, pkidata);
+            } else {
+                // none selfSign signes with  existing cert
+                System.out.println("selfSign is false...");
+                signedData = signData(signerCert, tokenName, nickname, cm, pkidata);
+            }
             if (signedData == null) {
                 System.out.println("signData() returns null. Exiting with error");
                 System.exit(1);
diff --git a/base/java-tools/src/com/netscape/cmstools/CRMFPopClient.java b/base/java-tools/src/com/netscape/cmstools/CRMFPopClient.java
index d0e5c27..0057a1d 100644
--- a/base/java-tools/src/com/netscape/cmstools/CRMFPopClient.java
+++ b/base/java-tools/src/com/netscape/cmstools/CRMFPopClient.java
@@ -86,6 +86,8 @@ import com.netscape.cmsutil.util.HMACDigest;
 import com.netscape.cmsutil.util.Utils;
 
 import netscape.security.util.WrappingParams;
+import netscape.security.x509.KeyIdentifier;
+import netscape.security.x509.PKIXExtensions;
 import netscape.security.x509.X500Name;
 
 /**
@@ -196,6 +198,8 @@ public class CRMFPopClient {
         option.setArgName("keySet");
         options.addOption(option);
 
+        options.addOption("y", false, "for Self-signed cmc.");
+
         options.addOption("v", "verbose", false, "Run in verbose mode.");
         options.addOption(null, "help", false, "Show help message.");
 
@@ -214,6 +218,9 @@ public class CRMFPopClient {
         System.out.println("  -k <true|false>              Attribute value encoding in subject DN (default: false)");
         System.out.println("                               - true: enabled");
         System.out.println("                               - false: disabled");
+        System.out.println("  -y <true|false>              Add SubjectKeyIdentifier extension in case of self-signed CMC requests (default: false)");
+        System.out.println("                               - true: enabled");
+        System.out.println("                               - false: disabled");
         System.out.println("  -a <rsa|ec>                  Key algorithm (default: rsa)");
         System.out.println("                               - rsa: RSA");
         System.out.println("                               - ec: ECC");
@@ -320,6 +327,8 @@ public class CRMFPopClient {
         int sensitive = Integer.parseInt(cmd.getOptionValue("s", "-1"));
         int extractable = Integer.parseInt(cmd.getOptionValue("e", "-1"));
 
+        boolean self_sign = cmd.hasOption("y");
+
         // get the key wrapping mechanism
         boolean keyWrap = true;
         if (cmd.hasOption("g")) {
@@ -516,6 +525,7 @@ public class CRMFPopClient {
 
             if (verbose) System.out.println("Creating certificate request");
             CertRequest certRequest = client.createCertRequest(
+                    self_sign,
                     token, transportCert, algorithm, keyPair,
                     subject, archivalMechanism, wrappingKeySet);
 
@@ -629,6 +639,19 @@ public class CRMFPopClient {
             Name subject,
             String archivalMechanism,
             String wrappingKeySet) throws Exception {
+        return createCertRequest(false, token, transportCert, algorithm, keyPair,
+            subject, archivalMechanism, wrappingKeySet);
+    }
+
+    public CertRequest createCertRequest(
+            boolean self_sign,
+            CryptoToken token,
+            X509Certificate transportCert,
+            String algorithm,
+            KeyPair keyPair,
+            Name subject,
+            String archivalMechanism,
+            String wrappingKeySet) throws Exception {
         EncryptionAlgorithm encryptAlg = null;
 
         if (wrappingKeySet == null) {
@@ -663,6 +686,15 @@ public class CRMFPopClient {
         seq.addElement(new AVA(OBJECT_IDENTIFIER.id_cmc_idPOPLinkWitness, ostr));
         */
 
+        if (self_sign) { // per rfc 5272
+            System.out.println("CRMFPopClient: self_sign true. Generating SubjectKeyIdentifier extension.");
+            KeyIdentifier subjKeyId = CryptoUtil.createKeyIdentifier(keyPair);
+            OBJECT_IDENTIFIER oid = new OBJECT_IDENTIFIER(PKIXExtensions.SubjectKey_Id.toString());
+            SEQUENCE extns = new SEQUENCE();
+            extns.addElement(new AVA(oid, new OCTET_STRING(subjKeyId.getIdentifier())));
+            certTemplate.setExtensions(extns);
+        }
+
         return new CertRequest(new INTEGER(1), certTemplate, seq);
     }
 
